// HtmlBar.cpp : Implementation of DLL Exports.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "HtmlBar.h"
#include "HtmlBar_i.c"

#include "HtmlExplorerBar.h"

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_HtmlBar, CHtmlBar)
END_OBJECT_MAP()


/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

HINSTANCE hInstRich = NULL;

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
   if (dwReason == DLL_PROCESS_ATTACH) {
      _Module.Init(ObjectMap, hInstance);
      
#if (_WIN32_IE >= 0x0300)
      INITCOMMONCONTROLSEX iccx;
      iccx.dwSize = sizeof(iccx);
      iccx.dwICC = ICC_COOL_CLASSES | ICC_BAR_CLASSES;
      BOOL bRet = ::InitCommonControlsEx(&iccx);
      bRet;
      ATLASSERT(bRet);
#else
      ::InitCommonControls();
#endif
      hInstRich = ::LoadLibrary(CRichEditCtrl::GetLibraryName());
      ATLASSERT(hInstRich != NULL);
      
      ::DisableThreadLibraryCalls(hInstance);
   }
   else if (dwReason == DLL_PROCESS_DETACH) {
      _Module.Term();
      ::FreeLibrary(hInstRich);
   }
   return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
    return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
   return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
   return _Module.UnregisterServer(TRUE);
}


